﻿-- Dispel module
local dispelSpell

function SN:SetupDispel()
	
	local f = SN.F
	local m = SN.Media
	local v = SN.db.profile.Frames

	f.dispel = CreateFrame("Frame", dispel, UIParent)
	f.dispel:SetPoint(unpack(v.dispel))
	f.dispel:SetWidth(250)
	f.dispel:SetHeight(50)
	f.dispel:SetClampedToScreen(true)
	
	f.dispel.TimeSinceLastUpdate = 0
	f.dispel.frameLocked = 1
	f.dispel.name = "dispel"
	f.dispel:SetScript("OnUpdate", function(self, elapsed)
		SN:SearchBuffs(self, elapsed)
	end)
	f.dispel:SetScript("OnEvent", function(self, event, ...)
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			local _, type, _, sourceGUID, sourceName, _, _, destGUID, destName = ...
			local spellID, spellName = select(12, ...)
			if type == "SPELL_DISPEL" then
				if spellID == dispelSpell then
					self.value:SetText("")
				end
			end
			if type == "SPELL_AURA_STOLEN" then
				if spellID == dispelSpell then
					self.value:SetText("")
				end
			end
		end
	end)
	f.dispel.value = f.dispel:CreateFontString(nil, "ARTWORK")
	f.dispel.value:SetFont(m.media.font, 16, "OUTLINE")
	f.dispel.value:SetTextColor(0.78, 0.25, 0.25)
	f.dispel.value:SetText("")
	f.dispel.value:SetAllPoints(f.dispel)
	f.dispel.value:SetJustifyH("CENTER")
	f.dispel.value:SetJustifyV("MIDDLE")

	f.dispel:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function SN:SearchBuffs(self, elapsed)
	--Make sure we don't hog cpu cycles checking it every millisecond
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed
	if self.TimeSinceLastUpdate > SN_UpdateInterval then

		self.TimeSinceLastUpdate = 0
		
		for i = 1, 40 do

			local stealableBuffs -- i = { }, 1
			local name, _, icon, _, debuffType, _, _, _, _, _, spellId, _, _ = UnitAura("target", i, "HELPFUL")
				
			if name ~= nil then
				canDispel, dispelSpell = SN.dispel:CanDispel("target", true, debuffType, spellId)
				if canDispel then
					self.value:SetText("You can "..GetSpellLink(dispelSpell).."\n\n"..name.." from "..UnitName("target"))
				end
			end
		end
	end
end
